!= ʬʿѤ
!
!= Operation for integral and average
!
! Authors::   Shin-ichi Takehiro, Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA
! Version::   $Id: $ 
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2011. All rights reserved.
! License::   See COPYRIGHT[link:../../../COPYRIGHT]
!

module intavr_operate
  !
  != ʬʿѤ
  !
  != Operation for integral and average
  !
  ! <b>Note that Japanese and English are described in parallel.</b>
  !
  ! ʬѤɸŤߤθʬʿΤδؿ󶡤ޤ. 
  ! {SPMODEL 饤֥}[http://www.gfd-dennou.org/library/spmodel]
  !  eea_integral_module.f90 򻲹ͤ˺ޤ. 
  !
  ! Functions for integral or average operation with weight for integration
  ! are provided
  ! This program is created referring to 
  ! "eea_integral_module.f90" in 
  ! {SPMODEL library}[http://www.gfd-dennou.org/library/spmodel]
  !
  !== Procedures List
  !
  ! IntXY_xy           :: ʿʬ
!!$  ! y_IntLon_xy, IntLon_x  :: ʬ
!!$  ! ya_IntLon_xya          :: ʬ (¿)
!!$  ! x_IntLat_xy, IntLat_y  :: ʬ
!!$  ! xa_IntLat_xya          :: ʬ (¿)
!!$  ! AvrLonLat_xy           :: ٷʿ
!!$  ! y_AvrLon_xy, AvrLon_x  :: ʿ
!!$  ! ya_AvrLon_xya          :: ʿ (¿)
!!$  ! x_AvrLat_xy, AvrLat_y  :: ʿ
!!$  ! xa_AvrLat_xya          :: ʿ (¿)
  ! ---------------------  :: ---------------------
  ! y_IntX_xy, IntX_x  :: integral in x direction
!!$  ! ya_IntLon_xya          :: Meridional integral (for multi layer)
!!$  ! x_IntLat_xy, IntLat_y  :: Zonal integral
!!$  ! xa_IntLat_xya          :: Zonal integral (for multi layer)
!!$  ! AvrLonLat_xy           :: Zonal and meridional average
!!$  ! y_AvrLon_xy, AvrLon_x  :: Meridional average
!!$  ! ya_AvrLon_xya          :: Meridional average (for multi layer)
!!$  ! x_AvrLat_xy, AvrLat_y  :: Zonal average
!!$  ! xa_AvrLat_xya          :: Zonal average (for multi layer)
  !
  !--
  !== NAMELIST
  !
  ! NAMELIST#intavr_operate_nml
  !++

  ! ⥸塼 ; USE statements
  !

  ! ɸǡ
  ! Axes data settings
  !
  use axesset, only: &
    & x_X_Weight, &
                              ! $ \Delta x$ [m] . 
                              ! X ɸŤ. 
                              ! Weight of x cordinate.
    & y_Y_Weight
                              ! $ \Delta y $ [m] . 
                              ! Y ɸŤ. 
                              ! Weight of y coordinate.

  ! ʻ
  ! Grid points settings
  !
  use gridset, only: imax, & ! X ʻ. 
                             ! Number of grid points in x direction
    &                jmax, & ! Y ʻ. 
                             ! Number of grid points in y direction
    &                kmax    ! ľؿ. 
                             ! Number of vertical level

  ! ̷ѥ᥿
  ! Kind type parameter
  !
  use dc_types, only: DP, &      ! ټ¿. Double precision. 
    &                 STRING     ! ʸ.       Strings. 

  ! å
  ! Message output
  !
  use dc_message, only: MessageNotify

  ! ʸ ; Declaration statements
  !
  implicit none
  private

  ! ³
  ! Public procedure
  !
  public:: IntXY_xy
!!$  public:: y_IntLon_xy, ya_IntLon_xya, IntLon_x
!!$  public:: x_IntLat_xy, xa_IntLat_xya, IntLat_y
!!$  public:: IntLat_y
!!$  public:: AvrLonLat_xy
!!$  public:: y_AvrLon_xy, ya_AvrLon_xya, AvrLon_x
!!$  public:: x_AvrLat_xy, xa_AvrLat_xya, AvrLat_y

  ! ѿ
  ! Public variables
  !
  logical, save, public:: intavr_operate_inited = .false.
                              ! ե饰. 
                              ! Initialization flag


  ! ѿ
  ! Private variables
  !

  character(*), parameter:: module_name = 'intavr_operate'
                              ! ⥸塼̾. 
                              ! Module name
  character(*), parameter:: version = &
    & '$Name:  $' // &
    & '$Id:  $'
                              ! ⥸塼ΥС
                              ! Module version

  ! INTERFACE ʸ ; INTERFACE statements
  !

contains

  !-------------------------------------------------------------------

  function IntXY_xy( xy_Data )
    !
    ! 2 ʿʻǡΰʬ(1 ). 
    !
    ! ºݤˤϳʻǡ x_X_Weight, y_Y_Weight ݤ
    ! ¤׻Ƥ. 
    !
    ! Global integration of 2-dimensional (horizontal)
    ! grid data.
    !
    ! Practically, the sum total of grid data is calculated
    ! by multiplying in each grid "x_X_Weight" and "y_YWeight".
    !

    real(DP), intent(in) :: xy_Data (0:imax-1, 1:jmax)
    real(DP)             :: IntXY_xy

    ! ¹ʸ ; Executable statement
    !

    ! Old one to be deleted
!!$    IntLonLat_xy = IntLon_x( x_IntLat_xy( xy_Data ) )

    IntXY_xy = IntY_y( y_IntX_xy( xy_Data ) )

  end function IntXY_xy

  !-------------------------------------------------------------------

  function y_IntX_xy( xy_Data )
    !
    ! 2 ʿʻǡ X ʬ(1 ). 
    !
    ! ºݤˤϳʻǡ x_X_Weight ݤ
    ! ¤׻Ƥ. 
    !
    ! x integration of 2-dimensional (horizontal)
    ! grid data.
    !
    ! Practically, the sum total of grid data is calculated
    ! by multiplying in each grid "x_X_Weight".
    !

    real(DP), intent(in) :: xy_Data (0:imax-1, 1:jmax)
    real(DP)             :: y_IntX_xy (1:jmax)

    ! ѿ
    ! Work variables
    !
    integer:: i               ! X ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in longitudinal direction
    integer:: j               ! Y ˲ DO 롼Ѻѿ
                              ! Work variables for DO loop in latitudinal direction

    ! ¹ʸ ; Executable statement
    !

    y_IntX_xy = 0.0_DP
    do j = 1, jmax
      do i = 0, imax - 1
        y_IntX_xy(j) = y_IntX_xy(j) + xy_Data (i,j) * x_X_Weight(i)
      end do
    end do

  end function y_IntX_xy

  !-------------------------------------------------------------------

  function IntY_y( y_Data )
    !
    ! 1  Y ʻǡ Y ʬ(1 ). 
    !
    ! ºݤˤϳʻǡ y_Y_Weight ݤ
    ! ¤׻Ƥ. 
    !
    ! Meridonal integration of 1-dimensional (y)
    ! grid data.
    !
    ! Practically, the sum total of grid data is calculated
    ! by multiplying in each grid "y_Y_Weight".
    !
    real(DP), intent(in) :: y_Data (1:jmax)
    real(DP)             :: IntY_y

    ! ѿ
    ! Work variables
    !

    ! ¹ʸ ; Executable statement
    !
    IntY_y = sum( y_Data * y_Y_Weight )

  end function IntY_y


  !--------------------------------------------------------------------------------------

  subroutine IntAvrOprInit
    !
    ! intavr_operate ⥸塼νԤޤ. 
    ! NAMELIST#intavr_operate_nml ɤ߹ߤϤμ³ǹԤޤ. 
    !
    ! "intavr_operate" module is initialized. 
    ! "NAMELIST#intavr_operate_nml" is loaded in this procedure. 
    !

    ! ⥸塼 ; USE statements
    !

    ! ʸ ; Declaration statements
    !

!!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
!!$                              ! Unit number for NAMELIST file open
!!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
!!$                              ! IOSTAT of NAMELIST read

    ! NAMELIST ѿ
    ! NAMELIST group name
    !
!!$    namelist /intavr_operate_nml/
          !
          ! ǥեͤˤĤƤϽ³ "intavr_operate#IntAvrOprInit" 
          ! Υɤ򻲾ȤΤ. 
          !
          ! Refer to source codes in the initialization procedure
          ! "intavr_operate#IntAvrOprInit" for the default values. 
          !

    ! ¹ʸ ; Executable statement
    !

    if ( intavr_operate_inited ) return


    ! ǥեͤ
    ! Default values settings
    !

!!$    ! NAMELIST ɤ߹
!!$    ! NAMELIST is input
!!$    !
!!$    if ( trim(namelist_filename) /= '' ) then
!!$      call FileOpen( unit_nml, &          ! (out)
!!$        & namelist_filename, mode = 'r' ) ! (in)
!!$
!!$      rewind( unit_nml )
!!$      read( unit_nml, &           ! (in)
!!$        & nml = intavr_operate_nml, &  ! (out)
!!$        & iostat = iostat_nml )   ! (out)
!!$      close( unit_nml )
!!$
!!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
!!$    end if

    !  ; Print
    !
    call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
    call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
    intavr_operate_inited = .true.
  end subroutine IntAvrOprInit

  !--------------------------------------------------------------------------------------

end module intavr_operate
